\ job.fs -- EPUT Lite (elite) for 300/600 chips -- 25Dec12rjn
\
false   constant tethered
true    constant turnkeyed
true    constant standalone

\ -----[ configure for 300 Dev ]
	$200  constant start        \ Reset vector.  Bootloader at $0000.
	$20B  constant TIM0         \ timer 0 interrupt
        $21B  constant TIM1         \ timer 1 overflow interrupt
        $223  constant RI           \ serial receive interrupt
        $22B  constant TIM2         \ timer 2 overflow interrupt
        $233  constant rom-start    \ start of code ($22b + $08)
\	$1DFE constant target-size  \ 8K flash, 512 reserved (IDE D/L error)
        $1df0 constant target-size  \ 8K flash, ~512 reserved (works with IDE)
\
\ -----[ load MyForth system ]
\ Note: full path is not needed, GForth knows about the myforth directory
include loader.fs
\ 
\ -----[ define SFRs ]
include sfr300.fs
\ 
\ -----[ compile bootloader ]
include bootloader300.fs 
\ 
rom-start org
\ 
\ -----[ serial I/O ]
\ needed for standalone, tether and debug
: emit ( c -)   begin 1 .SCON until. 1 .SCON clr SBUF #! ;
: key  ( - c)   begin 0 .SCON until. 0 .SCON clr SBUF #@ ;
\ 
\ -----[ Choose an interpreter ]
tethered   [if] include tether.fs [then]
standalone [if] [ cr cr ] include elite-standalone.fs [then] 
\
\ -----[ load the application ] 
\
\ elite.txt               \ doc file
\ [ cr cr ]                 \ whitespace for compilation summary
include elite-debug.fs    \ Comes before app., useful tools such as target ".s"
\ [ cr cr .s cr cr ]  \ debug
include 25_delays.fs      \ 25 MHz delays
include init.fs           \ init chip
include serial-strings.fs \ output strings to serial port
include xors.fs           \ xor macros
include xcells.fs         \ load/store multiple cells
include tri-digits.fs     \ display three bytes as decimal digits
include elite-event.fs    \ event counting
include elite-timer2.fs   \ timer2, generate intervals, count events
include elite-commands.fs \ command interpreter
include main.fs           \ functions and go definition
\ include interactive.fs    \ Should come _after_ application for efficiency.
[ cr cr ] 
\ 
\ -----[ patch the reset vector ]
turnkeyed [if]	\ Turnkeyed with go.
	start interrupt : cold stacks go ;
[else]	        \ Testing with quit.
	start interrupt : cold stacks quit ;
[then]
\ 
\ -----[ selects interactive or standalone ]
tethered [if]  \ interactive number entry
	:m # number emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[then]  
\
standalone [if]  \ standalone - patch dictionary pointer
\ Note: see config.fs -- headers are tacked on (moved) to the end of code by "headers"
        : r  cold ;
        headers ] here [ dict org heads ##p! org ] 
        [ .( heads start at: ) heads .  .(  size: ) ] 
		here [ heads - .  .(  bytes) ]
	here ( *) patch-cold org cold ( *) org  \ patch cold (after end of heads)
[then]
\
\ -----[ report build statistics ]
[ cr .( C8051F300: 8K memory) ]
report
save
[ .( Host stack= ) .s cr
