\ SFR300.fs  -- 27Dec12 rjn
\
\ -------------- Special function registers for the C8051F300 -------------
\
\ Also supports C8051T60x OTPs
\ 
\ ----- [ 8051 Registers defined in misc8051.fs ]------
\
false [if]
$82 constant DPL $83 constant DPH
$98 constant SCON : .SCON SCON +;
$99 constant SBUF
$80 constant P0 : .P0 P0 + ;
$90 constant P1 : .P1 P1 + ;
$a0 constant P2 : .P2 P2 + ;
$b0 constant P3 : .P3 P3 + ;
$81 constant SP
$d0 constant PSW  : .PSW  PSW + ;
$88 constant TCON : .TCON TCON + ;
$89 constant TMOD
$8a constant TL0 $8b constant TL1
$8c constant TH0 $8d constant TH1
$87 constant PCON  \ changed from $8f -- 04Sep09 rjn
$a8 constant IE : .IE IE + ;
$b8 constant IP : .IP IP + ;
$f0 constant B  : .B   B + ;
$fd constant SP0 $80 constant RP0
\ $100 constant SP0 $80 constant RP0
[then]

\ -----[ comparator 0 (only one!) ] \ 27Dec12 rjn
$9f constant CPT0MX  \ comparator 0 MUX selection
$f8 constant CPT0CN  \ comparator 0 configuration
$9d constant CPT0MD  \ comparator 0 response time
\ 
\
\ -----[ clock/oscillator ]
\
$b1 constant OSCXCN    \ external oscillator control
$b2 constant OSCICN    \ internal oscillator control

$8e constant CKCON     \ Clock Control
\
\ -----[ flash ]
\
$b6 constant FLSCL     \ Flash Scale
$b7 constant FLKEY     \ Flash Lock and Key
\
\ -----[ analog ]
\
$d1 constant REF0CN    \ voltage ref, analog configuration
$e8 constant ADC0CN    \ analog control
$bc constant ADC0CF    \ analog configuration
$be constant ADC0      \ data word
$bd constant ADC0L     \ lsb of 10-bit reading, *** T60x only ***
$be constant ADC0H     \ msb of 10-bit reading, *** T60x only ***
$bb constant AMX0SL    \ AMUX0 channel select
\
\ ---[ timer 2 ]       \ 02Sep10 rjn
\
$c8 constant TMR2CN    \ timer 2 control  
[ : .TMR2CN TMR2CN + ; ]  \ bit addressable
$ca constant TMR2RLL   \ timer 2 reload low
$cb constant TMR2RLH   \ timer 2 reload high
$cc constant TMR2L     \ Timer 2 low
$cd constant TMR2H     \ Timer 2 high

\
\ ---[ PCA ]
\
$d8 constant PCA0CN    \ PCA control
$d9 constant PCA0MD    \ PCA mode (0100 0000 reset)

$da constant PCA0CPM0  \ PCA0 capture/compare mode
$db constant PCA0CPM1  \ PCA1 capture/compare mode
$dc constant PCA0CPM2  \ PCA2 capture/compare mode

$fc constant PCA0CPH0  \ capture module 0 high byte
$ea constant PCA0CPH1  \ capture module 1 high byte
$ec constant PCA0CPH2  \ capture module 2 high byte

$fb constant PCA0CPL0  \ capture module 0 low byte
$e9 constant PCA0CPL1  \ capture module 1 low byte
$eb constant PCA0CPL2  \ capture module 2 low byte

$a4 constant P0MDOUT   \ P0 Output Mode
$f1 constant P0MDIN    \ P0 Input Mode
\
\ -----[ power ctl ]
\
$8f constant PSCTL

$ef constant RSTSRC    \ Reset Source

$98 constant SCON0     \ same as SCON
\
\ -----[ crossbar ]
\
$e1 constant XBR0      \ port I/O crossbar Rigister 0
$e2 constant XBR1      \ port I/O crossbar Register 1
$e3 constant XBR2      \ port I/O crossbar Register 2
